#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <locale>
#include <rena_api.h>

using namespace std;

//Send Single
void lina_send_single(void) {
	int level;
	string tmp;
	string tag;
	string msg;
	int result;

	//Choose level
	level = -1;
	while (level == -1) {
		cout << "Level (vdiwe):";
		getline(cin, tmp);
		if (tmp == "v") {
			level = RENA_LEVEL_VERBOSE;
		}
		else if (tmp == "d") {
			level = RENA_LEVEL_DEBUG;
		}
		else if (tmp == "i") {
			level = RENA_LEVEL_INFO;
		}
		else if (tmp == "w") {
			level = RENA_LEVEL_WARNING;
		}
		else if (tmp == "e") {
			level = RENA_LEVEL_ERROR;
		}
	}

	//Input tag
	tag = "";
	while (tag == "") {
		cout << "Tag:";
		getline(cin, tag);
	}

	//Input message (If you want to quit, Input "q")
	while (1) {
		cout << "Message:";
		getline(cin, msg);
		if (msg == "q") {
			cout << endl;
			break;
		}

		//Try send
		result = ::rena_send(level, tag.c_str(), msg.c_str());
		if (result == RENA_OK) {
			cout << "  Success." << endl;
		}
		else {
			//tere-
			cout << "  Failed." << endl;
		}
	}
}

//Send Continuous
void lina_send_continuous(void) {
	int count;
	int interval;
	char buffer[64];
	string tag = "lina_send_continuous";
	string line;
	int result;

	//Input interval
	while (1) {
		cout << "Interval(1-1000ms):";
		getline(cin, line);
		interval = atoi(line.c_str());
		if (interval < 1 || interval > 1000) {
			continue;
		}
	}

	//Input count
	while (1) {
		cout << "Count(1-10000):";
		getline(cin, line);
		count = atoi(line.c_str());
		if (count < 1 || count > 10000) {
			continue;
		}
	}

	//Execute
	cout << "Sending now..." << endl;
	for (int i = 0; i < count; i++) {
		sprintf(buffer, "This is continuous message. Count=%d", (i + 1));
		result = ::rena_send(RENA_LEVEL_DEBUG, tag.c_str(), buffer);
		if (result != RENA_OK) {
			cout << "Failed to send. Abort send continuous." << endl;
			break;
		}
		::Sleep(interval);
	}
	cout << "Completed." << endl << endl;
}

//Entry point
int main(int argc, char *argv[]) {
	string line;

	//Main menu
	cout << "VX Logger tester \"LINA\"" << endl;
	while (1) {
		cout << "1.Send Single Message" << endl;
		cout << "2.Send Continuous" << endl;
		cout << "q.Exit LINA" << endl;
		cout << "---------------------" << endl;
		cout << "> ";
		getline(cin, line);

		if (line == "1") {
			::lina_send_single();
		}
		else if (line == "2") {
			::lina_send_continuous();
		}
		else if (line == "q") {
			break;
		}
		else {
			cout << "Pardon?" << endl;
			cout << endl;
		}
	}

	//SATSUGAI
	return 0;
}
