#pragma once

#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN
#endif
#include <windows.h>
#include <vector>
#include <string>

using namespace std;

#define MANA_WM_RECV_LOG  (WM_USER + 1)

struct MANA_LOG {
	unsigned long tick;
	int level;
	string tag;
	string msg;
};

//Initialize model
void mana_model_init(HWND hwnd);

//Finalize model
void mana_model_final();

//Lock
void mana_model_lock(void);

//Unlock
void mana_model_unlock(void);

//Clear all logs
void mana_model_clear_logs();

//Get log list by multi condition
void mana_model_get_logs(unsigned int start, unsigned int count, int level, const string &tag, const string &filter, vector<MANA_LOG*> &logs);
